C
C      Frank matrix for Double-Double precision routine
C
       subroutine ddmatrix_set(n, ah, al, aih, ail)
       implicit double precision(a-h,o-z),integer(i-n)
       real(8)   :: ah(n,n), aih(n,n)
       real(8)   :: al(n,n), ail(n,n)
       real(16)  :: qtmp, qtmph, qtmpl

       do i=1,n
          do j=1,n
             if(i < j) then
               cycle
             else if(i == j) then

               CALL RANDOM_NUMBER(qtmp)
               tmph = qtmp
               qtmph = tmph
               qtmpl = qtmp - qtmph
               tmpl = qtmpl
               ah(i,j)=qtmph
               al(i,j)=qtmpl
               aih(i,j)=0.0d0
               ail(i,j)=0.0d0
             else
               CALL RANDOM_NUMBER(qtmp)
               tmph = qtmp
               qtmph = tmph
               qtmpl = qtmp - qtmph
               tmpl = qtmpl
               ah(i,j)=tmph
               al(i,j)=tmpl
               ah(j,i)=tmph
               al(j,i)=tmpl

               CALL RANDOM_NUMBER(qtmp)
               tmph = qtmp
               qtmph = tmph
               qtmpl = qtmp - qtmph
               tmpl = qtmpl
               aih(i,j)=tmph
               ail(i,j)=tmpl
               aih(j,i)=-tmph
               ail(j,i)=-tmpl
             end if
          enddo
       enddo

       return
       end
