!       subroutine ev_test2(ar,ai,w,zr,zi,n,nm)
       subroutine ddev_test2(arh,arl,aih,ail,wh,wl,zrh,zrl,zih,zil,n,nm)
!
!      use communication_h, only : eigen_init
!     &               , eigen_free
      use ddcommunication_h, only : eigen_init
     &                            , eigen_free
!
       integer                :: n, nm
!       real(8)                :: ar(*), ai(*), w(*), zr(*), zi(*)
       real(8)                :: arh(*), aih(*), wh(*), zrh(*), zih(*)
       real(8)                :: arl(*), ail(*), wl(*), zrl(*), zil(*)

       include 'mpif.h'
       include 'trd.h'

       call eigen_init(1)
       call MPI_Barrier(MPI_COMM_WORLD,ierr)
!       call ev_check2_body(ar(1),ai(1),w(1),zr(1),zi(1),n,nm)
       call ddev_check2_body(arh(1),arl(1),aih(1),ail(1),wh(1),wl(1),
     &                       zrh(1),zrl(1),zih(1),zil(1),n,nm)
       call MPI_Barrier(MPI_COMM_WORLD,ierr)
       call eigen_free(0)

       return
       end
*
*
*
!       subroutine ev_check2_body(ar,ai,w,zr,zi,n,nm)
       subroutine ddev_check2_body(arh,arl,aih,ail,wh,wl,
     &                             zrh,zrl,zih,zil,n,nm)
!
!      use communication_h, only : loop_c
      use ddcommunication_h, only : loop_c
!
       implicit double precision(a-h,o-z),integer(i-n)

       integer                :: n, nm
!       real(8)                :: ar(1:nm,*), ai(1:nm,*)
!       real(8)                :: w(1:n)
!       real(8)                :: zr(1:nm,*), zi(1:nm,*)
       real(8)                :: arh(1:nm,*), aih(1:nm,*)
       real(8)                :: arl(1:nm,*), ail(1:nm,*)
       real(8)                :: wh(1:n), wl(1:n)
       real(8)                :: zrh(1:nm,*), zih(1:nm,*)
       real(8)                :: zrl(1:nm,*), zil(1:nm,*)

!       real(8)                :: b(1:n)
!       real(8)                :: b1r(1:n), b1i(1:n)
       real(8)                :: bh(1:n), bl(1:n)
       real(8)                :: b1rh(1:n), b1ih(1:n)
       real(8)                :: b1rl(1:n), b1il(1:n)

!       real(8)                :: m_epsilon
      double precision m_epsilonh, m_epsilonl
       real(8), external      :: machine_epsilon
      double precision tmp1h, tmp1l
      double precision tmp2h, tmp2l
      double precision t_oneh, t_onel
!     tmp vars
      double precision t_ch, t_cl
      double precision t_p1, t_p2
      double precision t_q1, t_q2
      double precision t_r1, t_r2
      double precision t_s1, t_s2
      double precision t_t1, t_t2
      double precision t_u1, t_u2
      double precision t_x1, t_x2
      double precision t_y1, t_y2
      double precision t_z1, t_z2
      double precision t_x, t_ax
      double precision t_t1h, t_t1l
      double precision t_t2h, t_t2l

       include 'mpif.h'
       include 'trd.h'
*
!       m_epsilon = machine_epsilon()
       m_epsilonh = EPSILON(0.0d0)**2
       m_epsilonl = 0.0d0
      t_oneh = 1.0d+0
      t_onel = 0.0d+0

*
!       ra=0d0
!       rz=0d0
!       rr=0d0
!       r =0d0
!       b(1:n)=0d0
      rah = 0.0d+0
      ral = 0.0d+0
      rzh = 0.0d+0
      rzl = 0.0d+0
      rrh = 0.0d+0
      rrl = 0.0d+0
      rh = 0.0d+0
      rl = 0.0d+0
      bh(1:n) = 0.0d+0
      bl(1:n) = 0.0d+0

       do i=1,n,1

             i_3=MOD(i-1,nprocs)+1
             if(i_3==myrank)then
                i_1=(i-1)/nprocs+1
                do k=1,n
!                   b1r(k)=zr(k,i_1)
!                   b1i(k)=zi(k,i_1)
                   b1rh(k) = zrh(k,i_1)
                   b1rl(k) = zrl(k,i_1)
                   b1ih(k) = zih(k,i_1)
                   b1il(k) = zil(k,i_1)
                enddo
             endif
!             call MPI_Bcast(b1r(1),n,MPI_DOUBLE_PRECISION,i_3-1
!     1       ,MPI_COMM_WORLD,ierr)
!             call MPI_Bcast(b1i(1),n,MPI_DOUBLE_PRECISION,i_3-1
!     1       ,MPI_COMM_WORLD,ierr)
             call MPI_Bcast_dd(b1rh(1),b1rl(1),n,
     &                         MPI_DOUBLE_PRECISION,i_3-1,
     &                         MPI_COMM_WORLD,ierr)
             call MPI_Bcast_dd(b1ih(1),b1il(1),n,
     &                         MPI_DOUBLE_PRECISION,i_3-1,
     &                         MPI_COMM_WORLD,ierr)

             i_2=1
             i_3=n
             call loop_c(i_2,i_3,i_4,n, nprocs,myrank)
             do i_1=i_2,i_3
                j=(i_1-1)*nprocs+myrank
!                t1=0.0D+00
!                t2=0.0D+00
!                s1=0.0D+00
!                s2=0.0D+00
!                u =0.0D+00
                t1h = 0.0d+0
                t1l = 0.0d+0
                t2h = 0.0d+0
                t2l = 0.0d+0
                s1h = 0.0d+0
                s1l = 0.0d+0
                s2h = 0.0d+0
                s2l = 0.0d+0
                uh = 0.0d+0
                ul = 0.0d+0
                do k=1,n,1
!                   t1=t1+b1r(k)*ar(k,i_1) ! t = Az(i)
!     &                  +b1i(k)*ai(k,i_1) ! t = Az(i)
!                   t2=t2-b1r(k)*ai(k,i_1) ! t = Az(i)
!     &                  +b1i(k)*ar(k,i_1) ! t = Az(i)
!                   s1=s1+b1r(k)*zr(k,i_1) ! s = Zz(i)
!     &                  +b1i(k)*zi(k,i_1) ! s = Zz(i)
!                   s2=s2+b1r(k)*zi(k,i_1) ! s = Zz(i)
!     &                  -b1i(k)*zr(k,i_1) ! s = Zz(i)
!<<<               tmp1 = b1r(k) * ar(k,i_1)
                   tmp1h = b1rh(k) * arh(k,i_1)
                   t_u1 = 134217729.0 * b1rh(k)
                   t_p1 = t_u1
     +                      - (t_u1 - b1rh(k))
                   t_p2 = b1rh(k) - t_p1
                   t_u1 = 134217729.0 * arh(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - arh(k,i_1))
                   t_r2 = arh(k,i_1) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (b1rh(k)*arl(k,i_1)
     +                   + b1rl(k)*arh(k,i_1))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = b1r(k) * ar(k,i_1)
!<<<               t1 = t1 + tmp1
                   t_p1 = t1h + tmp1h
                   t_p2 = t_p1 - t1h
                   t_q1 = t_p1
                   t_q2 = (t1h - (t_p1 - t_p2))
     +                      + (tmp1h - t_p2)
                   t_q2 = t_q2 + t1l + tmp1l
                   t1h = t_q1 + t_q2
                   t1l = t_q2 - (t1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>               t1 = t1 + tmp1
!<<<               tmp1 = b1i(k) * ai(k,i_1)
                   tmp1h = b1ih(k) * aih(k,i_1)
                   t_u1 = 134217729.0 * b1ih(k)
                   t_p1 = t_u1
     +                      - (t_u1 - b1ih(k))
                   t_p2 = b1ih(k) - t_p1
                   t_u1 = 134217729.0 * aih(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - aih(k,i_1))
                   t_r2 = aih(k,i_1) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (b1ih(k)*ail(k,i_1)
     +                   + b1il(k)*aih(k,i_1))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = b1i(k) * ai(k,i_1)
!<<<               t1 = t1 + tmp1
                   t_p1 = t1h + tmp1h
                   t_p2 = t_p1 - t1h
                   t_q1 = t_p1
                   t_q2 = (t1h - (t_p1 - t_p2))
     +                      + (tmp1h - t_p2)
                   t_q2 = t_q2 + t1l + tmp1l
                   t1h = t_q1 + t_q2
                   t1l = t_q2 - (t1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>               t1 = t1 + tmp1
!<<<               tmp1 = b1r(k) * ai(k,i_1)
                   tmp1h = b1rh(k) * aih(k,i_1)
                   t_u1 = 134217729.0 * b1rh(k)
                   t_p1 = t_u1
     +                      - (t_u1 - b1rh(k))
                   t_p2 = b1rh(k) - t_p1
                   t_u1 = 134217729.0 * aih(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - aih(k,i_1))
                   t_r2 = aih(k,i_1) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (b1rh(k)*ail(k,i_1)
     +                   + b1rl(k)*aih(k,i_1))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = b1r(k) * ai(k,i_1)
!<<<               t2 = t2 - tmp1
                   t_p1 = t2h - tmp1h
                   t_p2 = t_p1 - t2h
                   t_ch = t_p1
                   t_cl = (t2h - (t_p1 - t_p2))
     +                      - (tmp1h + t_p2)
                   t_cl = t_cl + t2l - tmp1l
                   t_s1 = t_ch + t_cl
                   t2l = t_cl - (t_s1 - t_ch)
                   t2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>               t2 = t2 - tmp1
!<<<               tmp1 = b1i(k) * ar(k,i_1)
                   tmp1h = b1ih(k) * arh(k,i_1)
                   t_u1 = 134217729.0 * b1ih(k)
                   t_p1 = t_u1
     +                      - (t_u1 - b1ih(k))
                   t_p2 = b1ih(k) - t_p1
                   t_u1 = 134217729.0 * arh(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - arh(k,i_1))
                   t_r2 = arh(k,i_1) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (b1ih(k)*arl(k,i_1)
     +                   + b1il(k)*arh(k,i_1))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = b1i(k) * ar(k,i_1)
!<<<               t2 = t2 + tmp1
                   t_p1 = t2h + tmp1h
                   t_p2 = t_p1 - t2h
                   t_q1 = t_p1
                   t_q2 = (t2h - (t_p1 - t_p2))
     +                      + (tmp1h - t_p2)
                   t_q2 = t_q2 + t2l + tmp1l
                   t2h = t_q1 + t_q2
                   t2l = t_q2 - (t2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>               t2 = t2 + tmp1
!<<<               tmp1 = b1r(k) * zr(k,i_1)
                   tmp1h = b1rh(k) * zrh(k,i_1)
                   t_u1 = 134217729.0 * b1rh(k)
                   t_p1 = t_u1
     +                      - (t_u1 - b1rh(k))
                   t_p2 = b1rh(k) - t_p1
                   t_u1 = 134217729.0 * zrh(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - zrh(k,i_1))
                   t_r2 = zrh(k,i_1) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (b1rh(k)*zrl(k,i_1)
     +                   + b1rl(k)*zrh(k,i_1))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = b1r(k) * zr(k,i_1)
!<<<               s1 = s1 + tmp1
                   t_p1 = s1h + tmp1h
                   t_p2 = t_p1 - s1h
                   t_q1 = t_p1
                   t_q2 = (s1h - (t_p1 - t_p2))
     +                      + (tmp1h - t_p2)
                   t_q2 = t_q2 + s1l + tmp1l
                   s1h = t_q1 + t_q2
                   s1l = t_q2 - (s1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>               s1 = s1 + tmp1
!<<<               tmp1 = b1i(k) * zi(k,i_1)
                   tmp1h = b1ih(k) * zih(k,i_1)
                   t_u1 = 134217729.0 * b1ih(k)
                   t_p1 = t_u1
     +                      - (t_u1 - b1ih(k))
                   t_p2 = b1ih(k) - t_p1
                   t_u1 = 134217729.0 * zih(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - zih(k,i_1))
                   t_r2 = zih(k,i_1) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (b1ih(k)*zil(k,i_1)
     +                   + b1il(k)*zih(k,i_1))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = b1i(k) * zi(k,i_1)
!<<<               s1 = s1 + tmp1
                   t_p1 = s1h + tmp1h
                   t_p2 = t_p1 - s1h
                   t_q1 = t_p1
                   t_q2 = (s1h - (t_p1 - t_p2))
     +                      + (tmp1h - t_p2)
                   t_q2 = t_q2 + s1l + tmp1l
                   s1h = t_q1 + t_q2
                   s1l = t_q2 - (s1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>               s1 = s1 + tmp1
!<<<               tmp1 = b1r(k) * zi(k,i_1)
                   tmp1h = b1rh(k) * zih(k,i_1)
                   t_u1 = 134217729.0 * b1rh(k)
                   t_p1 = t_u1
     +                      - (t_u1 - b1rh(k))
                   t_p2 = b1rh(k) - t_p1
                   t_u1 = 134217729.0 * zih(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - zih(k,i_1))
                   t_r2 = zih(k,i_1) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (b1rh(k)*zil(k,i_1)
     +                   + b1rl(k)*zih(k,i_1))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = b1r(k) * zi(k,i_1)
!<<<               s2 = s2 + tmp1
                   t_p1 = s2h + tmp1h
                   t_p2 = t_p1 - s2h
                   t_q1 = t_p1
                   t_q2 = (s2h - (t_p1 - t_p2))
     +                      + (tmp1h - t_p2)
                   t_q2 = t_q2 + s2l + tmp1l
                   s2h = t_q1 + t_q2
                   s2l = t_q2 - (s2h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>               s2 = s2 + tmp1
!<<<               tmp1 = b1i(k) * zr(k,i_1)
                   tmp1h = b1ih(k) * zrh(k,i_1)
                   t_u1 = 134217729.0 * b1ih(k)
                   t_p1 = t_u1
     +                      - (t_u1 - b1ih(k))
                   t_p2 = b1ih(k) - t_p1
                   t_u1 = 134217729.0 * zrh(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - zrh(k,i_1))
                   t_r2 = zrh(k,i_1) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (b1ih(k)*zrl(k,i_1)
     +                   + b1il(k)*zrh(k,i_1))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = b1i(k) * zr(k,i_1)
!<<<               s2 = s2 - tmp1
                   t_p1 = s2h - tmp1h
                   t_p2 = t_p1 - s2h
                   t_ch = t_p1
                   t_cl = (s2h - (t_p1 - t_p2))
     +                      - (tmp1h + t_p2)
                   t_cl = t_cl + s2l - tmp1l
                   t_s1 = t_ch + t_cl
                   s2l = t_cl - (t_s1 - t_ch)
                   s2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>               s2 = s2 - tmp1
!                   u =u +SQRT(ar(k,i_1)**2   ! u = |A|_1
!     &                       +ai(k,i_1)**2)  ! u = |A|_1
!<<<               tmp1 = ar(k,i_1) * ar(k,i_1)
                   tmp1h = arh(k,i_1) * arh(k,i_1)
                   t_u1 = 134217729.0 * arh(k,i_1)
                   t_p1 = t_u1
     +                      - (t_u1 - arh(k,i_1))
                   t_p2 = arh(k,i_1) - t_p1
                   t_u1 = 134217729.0 * arh(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - arh(k,i_1))
                   t_r2 = arh(k,i_1) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (arh(k,i_1)*arl(k,i_1)
     +                   + arl(k,i_1)*arh(k,i_1))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = ar(k,i_1) * ar(k,i_1)
!<<<               tmp2 = ai(k,i_1) * ai(k,i_1)
                   tmp2h = aih(k,i_1) * aih(k,i_1)
                   t_u1 = 134217729.0 * aih(k,i_1)
                   t_p1 = t_u1
     +                      - (t_u1 - aih(k,i_1))
                   t_p2 = aih(k,i_1) - t_p1
                   t_u1 = 134217729.0 * aih(k,i_1)
                   t_r1 = t_u1
     +                      - (t_u1 - aih(k,i_1))
                   t_r2 = aih(k,i_1) - t_r1
                   tmp2l = ((t_p1*t_r1
     +                     - tmp2h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp2l = tmp2l
     +                   + (aih(k,i_1)*ail(k,i_1)
     +                   + ail(k,i_1)*aih(k,i_1))
                   t_s1 = tmp2h + tmp2l
                   tmp2l = tmp2l - (t_s1 - tmp2h)
                   tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp2 = ai(k,i_1) * ai(k,i_1)
!<<<               tmp1 = tmp1 + tmp2
                   t_p1 = tmp1h + tmp2h
                   t_p2 = t_p1 - tmp1h
                   t_q1 = t_p1
                   t_q2 = (tmp1h - (t_p1 - t_p2))
     +                      + (tmp2h - t_p2)
                   t_q2 = t_q2 + tmp1l + tmp2l
                   tmp1h = t_q1 + t_q2
                   tmp1l = t_q2 - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>               tmp1 = tmp1 + tmp2
!<<<               tmp1 = sqrt(tmp1)
                   if (tmp1h.eq.0.0D+0.and.tmp1l.eq.0.0D+0) then
                     tmp1h = 0.0d+0
                     tmp1l = 0.0d+0
                   endif
                   if (tmp1h.lt.0.0d+0.or.
     +                (tmp1h.eq.0.0d+0.and.tmp1l.lt.0.0d+0)) then
                     write(6,'(a)')
     +                  'SQRT CALLED WITH NEGATIVE ARGUMENT'
                     tmp1h = 0.0d+0
                     tmp1l = 0.0d+0
                     return
                   endif
                   t_x = 1.0D+0/sqrt(tmp1h)
                   t_ax = tmp1h * t_x
!                      call dd_mul(t_y1,t_y2,t_x,
!                                  0.0,0.5,0.0)
                       t_y1 = t_x * 0.5d+0
                       t_u1 = 134217729.0 * t_x
                       t_p1 = t_u1
     +                          - (t_u1 - t_x)
                       t_p2 = t_x - t_p1
                       t_u1 = 134217729.0 * 0.5d+0
                       t_r1 = t_u1
     +                          - (t_u1 - 0.5d+0)
                       t_r2 = 0.5d+0 - t_r1
                       t_y2 = ((t_p1*t_r1
     +                          - t_y1)
     +                          + t_p1*t_r2
     +                          + t_p2 * t_r1)
     +                          + t_p2 * t_r2
                       t_s1 = t_y1 + t_y2
                       t_y2 = t_y2
     +                          - (t_s1 - t_y1)
                       t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                      call dd_mul(t_z1,t_z2,t_ax,
!                                  0.0,t_ax,0.0)
                       t_z1 = t_ax * t_ax
                       t_u1 = 134217729.0 * t_ax
                       t_p1 = t_u1
     +                          - (t_u1 - t_ax)
                       t_p2 = t_ax - t_p1
                       t_u1 = 134217729.0 * t_ax
                       t_r1 = t_u1
     +                          - (t_u1 - t_ax)
                       t_r2 = t_ax - t_r1
                       t_z2 = ((t_p1 * t_r1
     +                          - t_z1)
     +                          + t_p1 * t_r2
     +                          + t_p2 * t_r1)
     +                          + t_p2*t_r2
                       t_s1 = t_z1 + t_z2
                       t_z2 = t_z2
     +                          - (t_s1 - t_z1)
                       t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                      call dd_sub(t_t2h,t_t2l,
!                           tmp1h,tmp1l,t_z1,t_z2)
                       t_p1 = tmp1h - t_z1
                       t_p2 = t_p1 - tmp1h
                       t_t2l = (tmp1h
     +                          -(t_p1 - t_p2))
     +                          -(t_z1 + t_p2)
                       t_t2h = t_p1
                       t_t2l = t_t2l
     +                          + tmp1l - t_z2
                       t_s1 = t_t2h + t_t2l
                       t_t2l = t_t2l
     +                          - (t_s1 - t_t2h)
                       t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                      call dd_mul(t_t1h,t_t1l,
!                                  t_t2h,t_t2l,
!                                  t_y1,t_y2)
                       t_t1h = t_t2h * t_y1
                       t_u1 = 134217729.0 * t_t2h
                       t_p1 = t_u1
     +                          - (t_u1 - t_t2h)
                       t_p2 = t_t2h - t_p1
                       t_u1 = 134217729.0 * t_y1
                       t_r1 = t_u1
     +                          - (t_u1 - t_y1)
                       t_r2 = t_y1 - t_r1
                       t_t1l = ((t_p1*t_r1
     +                          - t_t1h)
     +                          + t_p1*t_r2
     +                          + t_p2*t_r1)
     +                          + t_p2*t_r2
                       t_t1l = t_t1l
     +                          + (t_t2h * t_y2
     +                          +  t_t2l * t_y1)
                       t_s1 = t_t1h + t_t1l
                       t_t1l = t_t1l - (t_s1
     +                           - t_t1h)
                       t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                      call dd_selfadd(t_t1h,t_t1l,
!                                  t_ax,0.0)
                       t_p1 = t_t1h + t_ax
                       t_p2 = t_p1 - t_t1h
                       t_q2 = (t_t1h
     +                          - (t_p1 - t_p2))
     +                          + (t_ax - t_p2)
                       t_q1 = t_p1
                       t_q2 = t_q2 + t_t1l
                       t_t1h = t_q1 + t_q2
                       t_t1l = t_q2
     +                           - (t_t1h - t_q1)
                       tmp1h = t_t1h
                       tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>               tmp1 = sqrt(tmp1)
!<<<               u = u + tmp1
                   t_p1 = uh + tmp1h
                   t_p2 = t_p1 - uh
                   t_q1 = t_p1
                   t_q2 = (uh - (t_p1 - t_p2))
     +                      + (tmp1h - t_p2)
                   t_q2 = t_q2 + ul + tmp1l
                   uh = t_q1 + t_q2
                   ul = t_q2 - (uh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>               u = u + tmp1
                enddo! k
!                t1=t1-w(i)*b1r(j) ! t = Az(i) - wz(i)
!                t2=t2-w(i)*b1i(j) ! t = Az(i) - wz(i)
!<<<               tmp1 = w(i) * b1r(j)
                   tmp1h = wh(i) * b1rh(j)
                   t_u1 = 134217729.0 * wh(i)
                   t_p1 = t_u1
     +                      - (t_u1 - wh(i))
                   t_p2 = wh(i) - t_p1
                   t_u1 = 134217729.0 * b1rh(j)
                   t_r1 = t_u1
     +                      - (t_u1 - b1rh(j))
                   t_r2 = b1rh(j) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (wh(i)*b1rl(j)
     +                   + wl(i)*b1rh(j))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = w(i) * b1r(j)
!<<<               t1 = t1 - tmp1
                   t_p1 = t1h - tmp1h
                   t_p2 = t_p1 - t1h
                   t_ch = t_p1
                   t_cl = (t1h - (t_p1 - t_p2))
     +                      - (tmp1h + t_p2)
                   t_cl = t_cl + t1l - tmp1l
                   t_s1 = t_ch + t_cl
                   t1l = t_cl - (t_s1 - t_ch)
                   t1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>               t1 = t1 - tmp1
!<<<               tmp1 = w(i) * b1i(j)
                   tmp1h = wh(i) * b1ih(j)
                   t_u1 = 134217729.0 * wh(i)
                   t_p1 = t_u1
     +                      - (t_u1 - wh(i))
                   t_p2 = wh(i) - t_p1
                   t_u1 = 134217729.0 * b1ih(j)
                   t_r1 = t_u1
     +                      - (t_u1 - b1ih(j))
                   t_r2 = b1ih(j) - t_r1
                   tmp1l = ((t_p1*t_r1
     +                     - tmp1h)
     +                     + t_p1 * t_r2
     +                     + t_p2 * t_r1)
     +                     + t_p2 * t_r2
                   tmp1l = tmp1l
     +                   + (wh(i)*b1il(j)
     +                   + wl(i)*b1ih(j))
                   t_s1 = tmp1h + tmp1l
                   tmp1l = tmp1l - (t_s1 - tmp1h)
                   tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>               tmp1 = w(i) * b1i(j)
!<<<               t2 = t2 - tmp1
                   t_p1 = t2h - tmp1h
                   t_p2 = t_p1 - t2h
                   t_ch = t_p1
                   t_cl = (t2h - (t_p1 - t_p2))
     +                      - (tmp1h + t_p2)
                   t_cl = t_cl + t2l - tmp1l
                   t_s1 = t_ch + t_cl
                   t2l = t_cl - (t_s1 - t_ch)
                   t2h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>               t2 = t2 - tmp1
!                if(i==j) s1=s1-1.0D+00 ! s = Zz(i)-1(i)
                if(i==j) then
!<<<               s1 = s1 - t_one
                   t_p1 = s1h - t_oneh
                   t_p2 = t_p1 - s1h
                   t_ch = t_p1
                   t_cl = (s1h - (t_p1 - t_p2))
     +                      - (t_oneh + t_p2)
                   t_cl = t_cl + s1l - t_onel
                   t_s1 = t_ch + t_cl
                   s1l = t_cl - (t_s1 - t_ch)
                   s1h = t_s1
#ifdef FPCOUNTER
#include "fselfsub.h"
#endif
!>>>               s1 = s1 - t_one
                endif
!                b(i)=b(i)+SQRT(t1**2+t2**2) ! b(i)=|Az(i)-wz(i)|_1
!<<<            tmp1 = t1 * t1
                tmp1h = t1h * t1h
                t_u1 = 134217729.0 * t1h
                t_p1 = t_u1
     +                   - (t_u1 - t1h)
                t_p2 = t1h - t_p1
                t_u1 = 134217729.0 * t1h
                t_r1 = t_u1
     +                   - (t_u1 - t1h)
                t_r2 = t1h - t_r1
                tmp1l = ((t_p1*t_r1
     +                  - tmp1h)
     +                  + t_p1 * t_r2
     +                  + t_p2 * t_r1)
     +                  + t_p2 * t_r2
                tmp1l = tmp1l
     +                + (t1h*t1l
     +                + t1l*t1h)
                t_s1 = tmp1h + tmp1l
                tmp1l = tmp1l - (t_s1 - tmp1h)
                tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>            tmp1 = t1 * t1
!<<<            tmp2 = t2 * t2
                tmp2h = t2h * t2h
                t_u1 = 134217729.0 * t2h
                t_p1 = t_u1
     +                   - (t_u1 - t2h)
                t_p2 = t2h - t_p1
                t_u1 = 134217729.0 * t2h
                t_r1 = t_u1
     +                   - (t_u1 - t2h)
                t_r2 = t2h - t_r1
                tmp2l = ((t_p1*t_r1
     +                  - tmp2h)
     +                  + t_p1 * t_r2
     +                  + t_p2 * t_r1)
     +                  + t_p2 * t_r2
                tmp2l = tmp2l
     +                + (t2h*t2l
     +                + t2l*t2h)
                t_s1 = tmp2h + tmp2l
                tmp2l = tmp2l - (t_s1 - tmp2h)
                tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>            tmp2 = t2 * t2
!<<<            tmp1 = tmp1 + tmp2
                t_p1 = tmp1h + tmp2h
                t_p2 = t_p1 - tmp1h
                t_q1 = t_p1
                t_q2 = (tmp1h - (t_p1 - t_p2))
     +                   + (tmp2h - t_p2)
                t_q2 = t_q2 + tmp1l + tmp2l
                tmp1h = t_q1 + t_q2
                tmp1l = t_q2 - (tmp1h - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>            tmp1 = tmp1 + tmp2
!<<<            tmp1 = sqrt(tmp1)
                if (tmp1h.eq.0.0D+0.and.tmp1l.eq.0.0D+0) then
                  tmp1h = 0.0d+0
                  tmp1l = 0.0d+0
                endif
                if (tmp1h.lt.0.0d+0.or.
     +             (tmp1h.eq.0.0d+0.and.tmp1l.lt.0.0d+0)) then
                  write(6,'(a)')
     +               'SQRT CALLED WITH NEGATIVE ARGUMENT'
                  tmp1h = 0.0d+0
                  tmp1l = 0.0d+0
                  return
                endif
                t_x = 1.0D+0/sqrt(tmp1h)
                t_ax = tmp1h * t_x
!                   call dd_mul(t_y1,t_y2,t_x,
!                               0.0,0.5,0.0)
                    t_y1 = t_x * 0.5d+0
                    t_u1 = 134217729.0 * t_x
                    t_p1 = t_u1
     +                       - (t_u1 - t_x)
                    t_p2 = t_x - t_p1
                    t_u1 = 134217729.0 * 0.5d+0
                    t_r1 = t_u1
     +                       - (t_u1 - 0.5d+0)
                    t_r2 = 0.5d+0 - t_r1
                    t_y2 = ((t_p1*t_r1
     +                       - t_y1)
     +                       + t_p1*t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2 * t_r2
                    t_s1 = t_y1 + t_y2
                    t_y2 = t_y2
     +                       - (t_s1 - t_y1)
                    t_y1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                   call dd_mul(t_z1,t_z2,t_ax,
!                               0.0,t_ax,0.0)
                    t_z1 = t_ax * t_ax
                    t_u1 = 134217729.0 * t_ax
                    t_p1 = t_u1
     +                       - (t_u1 - t_ax)
                    t_p2 = t_ax - t_p1
                    t_u1 = 134217729.0 * t_ax
                    t_r1 = t_u1
     +                       - (t_u1 - t_ax)
                    t_r2 = t_ax - t_r1
                    t_z2 = ((t_p1 * t_r1
     +                       - t_z1)
     +                       + t_p1 * t_r2
     +                       + t_p2 * t_r1)
     +                       + t_p2*t_r2
                    t_s1 = t_z1 + t_z2
                    t_z2 = t_z2
     +                       - (t_s1 - t_z1)
                    t_z1 = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                   call dd_sub(t_t2h,t_t2l,
!                           tmp1h,tmp1l,t_z1,t_z2)
                    t_p1 = tmp1h - t_z1
                    t_p2 = t_p1 - tmp1h
                    t_t2l = (tmp1h
     +                       -(t_p1 - t_p2))
     +                       -(t_z1 + t_p2)
                    t_t2h = t_p1
                    t_t2l = t_t2l
     +                       + tmp1l - t_z2
                    t_s1 = t_t2h + t_t2l
                    t_t2l = t_t2l
     +                       - (t_s1 - t_t2h)
                    t_t2h = t_s1
#ifdef FPCOUNTER
#include "fsub.h"
#endif
!                   call dd_mul(t_t1h,t_t1l,
!                               t_t2h,t_t2l,
!                               t_y1,t_y2)
                    t_t1h = t_t2h * t_y1
                    t_u1 = 134217729.0 * t_t2h
                    t_p1 = t_u1
     +                       - (t_u1 - t_t2h)
                    t_p2 = t_t2h - t_p1
                    t_u1 = 134217729.0 * t_y1
                    t_r1 = t_u1
     +                       - (t_u1 - t_y1)
                    t_r2 = t_y1 - t_r1
                    t_t1l = ((t_p1*t_r1
     +                       - t_t1h)
     +                       + t_p1*t_r2
     +                       + t_p2*t_r1)
     +                       + t_p2*t_r2
                    t_t1l = t_t1l
     +                       + (t_t2h * t_y2
     +                       +  t_t2l * t_y1)
                    t_s1 = t_t1h + t_t1l
                    t_t1l = t_t1l - (t_s1
     +                        - t_t1h)
                    t_t1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!                   call dd_selfadd(t_t1h,t_t1l,
!                               t_ax,0.0)
                    t_p1 = t_t1h + t_ax
                    t_p2 = t_p1 - t_t1h
                    t_q2 = (t_t1h
     +                       - (t_p1 - t_p2))
     +                       + (t_ax - t_p2)
                    t_q1 = t_p1
                    t_q2 = t_q2 + t_t1l
                    t_t1h = t_q1 + t_q2
                    t_t1l = t_q2
     +                        - (t_t1h - t_q1)
                    tmp1h = t_t1h
                    tmp1l = t_t1l
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>            tmp1 = sqrt(tmp1)
!<<<            b(i) = b(i) + tmp1
                t_p1 = bh(i) + tmp1h
                t_p2 = t_p1 - bh(i)
                t_q1 = t_p1
                t_q2 = (bh(i) - (t_p1 - t_p2))
     +                   + (tmp1h - t_p2)
                t_q2 = t_q2 + bl(i) + tmp1l
                bh(i) = t_q1 + t_q2
                bl(i) = t_q2 - (bh(i) - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>            b(i) = b(i) + tmp1
!                rz=rz+s1**2+s2**2
!<<<            tmp1 = s1 * s1
                tmp1h = s1h * s1h
                t_u1 = 134217729.0 * s1h
                t_p1 = t_u1
     +                   - (t_u1 - s1h)
                t_p2 = s1h - t_p1
                t_u1 = 134217729.0 * s1h
                t_r1 = t_u1
     +                   - (t_u1 - s1h)
                t_r2 = s1h - t_r1
                tmp1l = ((t_p1*t_r1
     +                  - tmp1h)
     +                  + t_p1 * t_r2
     +                  + t_p2 * t_r1)
     +                  + t_p2 * t_r2
                tmp1l = tmp1l
     +                + (s1h*s1l
     +                + s1l*s1h)
                t_s1 = tmp1h + tmp1l
                tmp1l = tmp1l - (t_s1 - tmp1h)
                tmp1h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>            tmp1 = s1 * s1
!<<<            tmp2 = s2 * s2
                tmp2h = s2h * s2h
                t_u1 = 134217729.0 * s2h
                t_p1 = t_u1
     +                   - (t_u1 - s2h)
                t_p2 = s2h - t_p1
                t_u1 = 134217729.0 * s2h
                t_r1 = t_u1
     +                   - (t_u1 - s2h)
                t_r2 = s2h - t_r1
                tmp2l = ((t_p1*t_r1
     +                  - tmp2h)
     +                  + t_p1 * t_r2
     +                  + t_p2 * t_r1)
     +                  + t_p2 * t_r2
                tmp2l = tmp2l
     +                + (s2h*s2l
     +                + s2l*s2h)
                t_s1 = tmp2h + tmp2l
                tmp2l = tmp2l - (t_s1 - tmp2h)
                tmp2h = t_s1
#ifdef FPCOUNTER
#include "fmul.h"
#endif
!>>>            tmp2 = s2 * s2
!<<<            rz = rz + tmp1
                t_p1 = rzh + tmp1h
                t_p2 = t_p1 - rzh
                t_q1 = t_p1
                t_q2 = (rzh - (t_p1 - t_p2))
     +                   + (tmp1h - t_p2)
                t_q2 = t_q2 + rzl + tmp1l
                rzh = t_q1 + t_q2
                rzl = t_q2 - (rzh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>            rz = rz + tmp1
!<<<            rz = rz + tmp2
                t_p1 = rzh + tmp2h
                t_p2 = t_p1 - rzh
                t_q1 = t_p1
                t_q2 = (rzh - (t_p1 - t_p2))
     +                   + (tmp2h - t_p2)
                t_q2 = t_q2 + rzl + tmp2l
                rzh = t_q1 + t_q2
                rzl = t_q2 - (rzh - t_q1)
#ifdef FPCOUNTER
#include "fselfadd.h"
#endif
!>>>            rz = rz + tmp2
!                ra=MAX(ra,u)
                if (
!                    (ra .lt. u)
     +              ((rah .lt. uh) .or.
     +               ((rah .eq. uh) .and.
     +                (ral .lt. ul)))
     &          ) then
                   rah = uh
                   ral = ul
                endif
             enddo
       enddo
*>

!       b1r(1:n)=b(1:n)
!       call MPI_Allreduce(b,b1r,n,MPI_DOUBLE_PRECISION,
!     &                    MPI_SUM,MPI_COMM_WORLD,ierr)
!       b(1:n)=b1r(1:n)
                   b1rh(1:n) = bh(1:n)
                   b1rl(1:n) = bl(1:n)
       call MPI_Allreduce_dd(bh,bl,b1rh,b1rl,n,MPI_DOUBLE_PRECISION,
     &                       MPI_SUM,MPI_COMM_WORLD,ierr)
                   bh(1:n) = b1rh(1:n)
                   bl(1:n) = b1rl(1:n)
!       r=ra
!       call MPI_Allreduce(ra,r,1,MPI_DOUBLE_PRECISION,
!     &                    MPI_MAX,MPI_COMM_WORLD,ierr)
!       ra=r
                   rh = rah
                   rl = ral
       call MPI_Allreduce_dd(rah,ral,rh,rl,1,MPI_DOUBLE_PRECISION,
     &                       MPI_MAX,MPI_COMM_WORLD,ierr)
                   rah = rh
                   ral = rl
!       r=rz
!       call MPI_Allreduce(rz,r,1,MPI_DOUBLE_PRECISION,
!     1                    MPI_SUM,MPI_COMM_WORLD,ierr)
!       rz=r
                   rh = rzh
                   rl = rzl
       call MPI_Allreduce_dd(rzh,rzl,rh,rl,1,MPI_DOUBLE_PRECISION,
     1                       MPI_SUM,MPI_COMM_WORLD,ierr)
                   rzh = rh
                   rzl = rl

!       rr=0d0
                   rrh = 0.0d+0
                   rrl = 0.0d+0
       do i=1,n
!          if(b(i)>rr)then
          if(
!              (b(i) .gt. rr)
     +        ((bh(i) .gt. rrh) .or.
     +         ((bh(i) .eq. rrh) .and.
     +          (bl(i) .gt. rrl)))
     &    ) then
             rrh = bh(i)
             rrl = bl(i)
             k=i
          endif
       enddo! i

!       print*,b(1:n)

       if(myrank==1)then
!          print*," "
!          print*,"----- Check a calculation result. -----"
!          print*,"max|Ax-wx|=",rr,k
!          print*,"|A|=",ra
!          print*,"epsilon=",m_epsilon
!          print*,"max|Ax-wx|/Ne|A|=",rr/(n*m_epsilon*ra)
!          print*,"|ZZ-I|=",SQRT(rz),rz
!          print*,"---------------------------------------"
          print*," "
          print*,"----- Check a calculation result. -----"
          print*,"max|Ax-wx|=",rrh,rrl,k
          print*,"|A|=",rah,ral
          print*,"epsilon=",m_epsilonh
          print*,"max|Ax-wx|/Ne|A|=",rrh/(n*m_epsilonh*rah)
          print*,"|ZZ-I|=",SQRT(rzh),rzh
          print*,"---------------------------------------"
       endif
*
       return
       end
