C
C      Subroutine for diagonal matrix with Double-Double percision
C
       subroutine ddmatrix_diagonal(n, ah, al, aih, ail,wh,wl)
       implicit double precision(a-h,o-z),integer(i-n)
       real(8)   :: ah(n,n), aih(n,n)
       real(8)   :: al(n,n), ail(n,n)
       real(8)   :: wh(n), wl(n)

       real(8)   :: temp_h, temp_l
       real(16)  :: qtmp, qtmph, qtmpl

       do i=1,n
          do j=1,n
             if(i == j) then
               CALL RANDOM_NUMBER(qtmp)
               tmph = qtmp
               qtmph = tmph
               qtmpl = qtmp - qtmph
               tmpl = qtmpl
               ah(i,j)=qtmph
               al(i,j)=qtmpl
               aih(i,j)=0.0d0
               ail(i,j)=0.0d0
	       wh(i)=ah(i,j)
               wl(i)=al(i,j)
             else
               aih(i,j)=0.0d0
               ail(i,j)=0.0d0
               aih(j,i)=0.0d0
               ail(j,i)=0.0d0
             end if
          enddo
       enddo

       return
       end
